#This script only work in bash
#!/system/xbin/bash
#change to /sbin/bash if Linux
#Option list
OPTS="Replace Cut Add Shell Help Config Exit"
PRESUF="Prefix Suffix"
STRNUM="String Number"
CONFIG="Default.."
#Acutually CONFIG will be overwrite
#Consts
NAME="\033[1mBatch Rename\033[22m"
VERSION="\033[1m1.04\033[22m"
BUILD="\033[1m2012.6 5\033[22m"
COPYRIGHT="\n\033[1mCopyright (C) 2012, fffonion.\033[22mHaven't been licenced under GPLv2 or other yet.\nT^T\n"
#Configuration vars
PS3="Select> "
#error codes
#1:bash or busybox not found

br_nprint()
{
	echo -n -e "\033[36m"$@"\033[0m"
}

br_errprt()
{
	#if [ ! $@"." = "." ];then
		echo -e "\033[31m"$@"\033[0m" >&2
	#fi
}

br_normalprt()
{
	#echo -e "\033[37m"$@"\033[0m"
	echo -e "\033[0m"$@"\033[0m"
}

br_helpprt()
{
	echo -e "\033[32m"$@"\033[0m"
}

br_promptprt()
{
	echo -e "\033[4m"$@"\033[24m"
}

br_flush()
{
	BRDIR_BF=""
	COUNT=0	
	PATTERN=""
	SUFFIX=""
	PREFIX=""
	REPLACE=""	
	FILENAME=""
	NUM_START=0
	NUM_STEP=1
	#DESC=0
	USINGNUM=0
	file=""
	DONOTHING=false
	DEPTH="|"				#to draw a tree
}

br_flushconfig()
{
	RECURSE=false
	MATCH_ALL=true
	SHOWPROGRESS=true
	TESTMODE=false
}

br_help()
{
	br_helpprt "$NAME by Onion v$VERSION build $BUILD\n$COPYRIGHT\n"
	br_helpprt "Usage: br PATH -rca[taRu] [arguments]...\n"
	br_helpprt "$NAME is a bash script to help you manage filenames more efficiently.\n"
	br_helpprt "Enter (like) $0 without arguments for a text UI."
	br_helpprt "\t--help\tThis help."
	br_helpprt "\t--version-t\tPrint version."
	br_helpprt "\t-r PATTERN REPLACE\n\t\tReplace pattern string with replace string."
	br_helpprt "\t-a PREFIX SUFFIX\n\t\tAdd prefix and suffix."
	br_helpprt "\t-c PATTERN\n\t\tRemove pattern string."
		br_helpprt "\t-u\tUse saved config(if exist)."
		br_helpprt "\t-a\tMatch all patterns."
		br_helpprt "\t-s\tSilent mode.Do not show progress."
		br_helpprt "\t-R\tRecurse."
		br_helpprt "\t-t\tTest mode(don't take effect)."
}

br_helpUI()
{
	local p	
	br_helpprt "\n$NAME is a bash script to help you manage filename more efficiently.\n"
	br_helpprt "Follow the menu and input the number of your choice.\n"
	br_helpprt "Use Shell for a quick access to interpreter.\n"
	br_helpprt "Tips:When entering path for the second time, press enter to use last specified path"
	br_nprint "More?(y/n)"
	read p
	if [ $p"." = "y." ] || [ $p"." = "." ];then 
		br_helpprt "\033[1m[Useful Information]\033[22m"
		br_helpprt "\033[1mWhereis Script:\033[22m $0\n\033[1mConfig file:\033[22m  $SAVEPATH\n\033[1mCurrent path: \033[22m$BRDIR\t\033[1mRoot user:\033[22m $ROOTED\n\033[1mBINARY:\033[22m $BINARY"
	fi
	 
}

br_checksupport()
{
	if [ -e /system/bin/busybox ];then
		BINARY="/system/bin/busybox "
		#Debug only
	elif [ -e /system/xbin/busybox ];then
		BINARY="/system/xbin/busybox "
	elif ! ls >/dev/null 2>&1;then
		br_errprt "Basic shell binary not found.\nYou may install them first."
		br_normalprt "Or enter a \033[1mbusybox\033[22m path below."
		BINARY="|"
		while ! $BINARY >/dev/null 2>&1;do
			if ! [ "$BINARY." = "|." ];then
				br_errprt "\033[1m$BINARY\033[22m not found or permission denied."
			fi
			br_nprint "Busybox(esc for escape):"
			read BINARY
			if [ "$BINARY." = "esc." ] || [ "$BINARY." = "." ];then
				br_helpprt Canceled.
				exit 1
			fi
		done
	elif ! bash --version >/dev/null 2>&1;then
		br_errprt Bash not found.
		exit 1
	else
		BINARY=""
	fi
	BR_LS=$BINARY"ls"
	BR_CAT=$BINARY"cat"
	BR_MV=$BINARY"mv"
	BR_BASENAME=$BINARY"basename"
	BR_CD="cd"

}

br_checkpath()
{
	if $BR_LS /data/data > /dev/null 2>&1;then
		#someone may say -e ..su is better, but concerning rooted users running unroot terminal.
		ROOTED=true
	else
		ROOTED=false
	fi

	if [ -d /mnt/asec/ ] && $ROOTED;then
		#is android
		SAVEPATH="/data/.br_config"
	elif [ -d /mnt/asec/ ] && ! $ROOTED;then
		SAVEPATH="/sdcard/.br_config"
	else
		#common linux
		USERNAME=`id |cut -f 1 -d ' '|sed 's/.\+(//'|sed 's/)//'`
		SAVEPATH="/home/$USERNAME/.br_config"
	fi 
}

br_setconfig()
{
	br_checkpath
	echo "$SHOWPROGRESS $RECURSE $MATCH_ALL $TESTMODE $BRDIR $BINARY" > $SAVEPATH
}

br_getconfig()
{
	br_checkpath
	if ! $BR_CAT $SAVEPATH > /dev/null 2>&1;then
		#first run
		br_checksupport
		br_flushconfig
	else
		read SHOWPROGRESS RECURSE MATCH_ALL TESTMODE BRDIR BINARY < $SAVEPATH
		#echo  $SHOWPROGRESS $RECURSE $MATCH_ALL $BRDIR
	fi
}

br_initcfg()
{
 	#Init CONFIG opts
	if $SHOWPROGRESS;then
		CONFIG="Progress:On"
	else
		CONFIG="Progress:Off"
	fi
 	if $RECURSE;then
		CONFIG=$CONFIG" Recurse:On"
	else
		CONFIG=$CONFIG" Recurse:Off"
	fi
 	if $MATCH_ALL;then
		CONFIG=$CONFIG" Match:All"
	else
		CONFIG=$CONFIG" Match:Once"
	fi
	if $TESTMODE;then
		CONFIG=$CONFIG" Test:On"
	else
		CONFIG=$CONFIG" Test:Off"
	fi
 CONFIG=$CONFIG" Default.."
 
}

br_config()
{
	br_promptprt "\033[1m[Setup Menu]\033[22m" 
	br_initcfg
	select opt in $CONFIG;do
	if [ $opt"." = "Progress:Off." ];then
		SHOWPROGRESS=true
		br_normalprt I will show you the progree.
	elif [ $opt"." = "Progress:On." ];then
		SHOWPROGRESS=false
		br_normalprt I will no longer show progress.
 	elif [ $opt"." = "Recurse:Off." ];then
		RECURSE=true
		br_normalprt I will now recurse into folders.
	elif [ $opt"." = "Recurse:On." ];then
		RECURSE=false
		br_normalprt I will not recurse into folders.
 	elif [ $opt"." = "Match:Onc." ];then
		MATCH_ALL=true
		br_normalprt I will match all the patterns.
	elif [ $opt"." = "Match:All." ];then
		MATCH_ALL=false
		br_normalprt I will only match the first pattern.
 	elif [ $opt"." = "Test:On." ];then
		TESTMODE=false
		br_normalprt Renaming will take effect.
	elif [ $opt"." = "Test:Off." ];then
		TESTMODE=true
		br_normalprt Renaming will only be showed as preview. 
	elif [ $opt"." = "Default..." ];then
		br_flushconfig
		br_helpprt "Custom setting cleaned."
		rm $SAVEPATH >/dev/null 2>&1
 	#elif [ $opt"." = "." ];then
 	 	#br_helpprt "Show progress? $PROGRESS\tRecurse? $RECURSE\nReplace all? $MATCH_ALL"
 	else
		br_errprt "Bad choice."
		continue
	fi
	break
	done
}

br_setdir()
{
	local p
	br_nprint "Specify the path(Enter for last path)":
	BRDIR_BF=$BRDIR
	read BRDIR
	if [ $BRDIR"." = "." ];then
		BRDIR=$BRDIR_BF
	fi
	if ! ls $BRDIR >/dev/null 2>&1;then
		br_errprt "$BRDIR not exist."
		br_nprint "Continue?(y/n):"
		read p
		if ! ( [ $p"." = "." ] || [ $p"." = "y." ] );then
			br_setdir
		fi
	fi
}


br_do()
{
	local COUNT_BF=$COUNT
	COUNT=0
	local DEPTH_BF=$DEPTH
	DEPTH=$DEPTH"-"
	if [ $1"." = "." ] || ! $BR_CD $1 >/dev/null 2>&1;then
		br_errprt "Error parsing path, exiting action..."
		DONOTHING=true
	fi
	local FILENAME_AFTER=""
	if ! $DONOTHING;then
		br_helpprt $DEPTH"Now listing files in $1 ..."
	fi
	
	for file in `$BR_LS -Ad "$1"/* 2>/dev/null |sed 's/ /-THIS_IS_SPACE-/g'`; do
		file=`echo $file|sed 's/-THIS_IS_SPACE-/ /g'`
		#echo $file
		if $DONOTHING;then
			break
		fi
	  	local FILENAME=$($BR_BASENAME "$file")
		if $MATCH_ALL;then
				FILENAME_AFTER=${FILENAME//$PATTERN/$REPLACE}
		else
				FILENAME_AFTER=${FILENAME/$PATTERN/$REPLACE}
		fi
			#echo ${file/$PATTERN/$REPLACE}
		if [ -d "$file" ] && $RECURSE;then
			br_do "$file"
		else
			if ! ( [ "$PATTERN$REPLACE." = "." ]  || ! [ -e "$FILENAME_AFTER" ]);then
		#means:
		#|NO INPUT|  MATCH  ||   GO?   |
		#|   T    |    T    ||    T    |
		#|   F    |    F    ||    T    |
		#|   F    |    T    ||    F    |
		#|   T    |    F    |Impossible|
		#A simple !XOR can handle this, but not found in bash script...
				continue
			else
				let "COUNT=$COUNT+1"
				if [ $USINGNUM = 1 ];then
					let "PREFIX= $NUM_START+($COUNT-1)*$NUM_STEP"
				elif [ $USINGNUM = 2 ];then
					let "SUFFIX= $NUM_START+($COUNT-1)*$NUM_STEP"
				fi
				#-1 is offset for . and ..
				FILENAME_AFTER="$PREFIX$FILENAME_AFTER$SUFFIX"
				#echo $FILENAME_AFTER
				if ! $TESTMODE;then
					$BR_MV "$file" "$FILENAME_AFTER" #>/dev/null 2>&1
					PRMPT_1="Renaming"
					PRMPT_2=""
				else
					PRMPT_1="Will rename"
					PRMPT_2=" will be"
				fi
				if $SHOWPROGRESS;then
					br_normalprt "\033[33m"$DEPTH"$PRMPT_1 : $($BR_BASENAME $file) > $($BR_BASENAME $FILENAME_AFTER)"
				fi	
			fi
		fi	
	done
	br_normalprt "\033[33;1m$DEPTH$COUNT file(s)$PRMPT_2 renamed in folder $1\033[22m"
	COUNT=$COUNT_BF
	DEPTH=$DEPTH_BF
	#go back to father folder
	$BR_CD ..
} 

br_cut()
{
	br_setdir
	br_nprint "Pattern:"
	read PATTERN
	br_do $BRDIR
}

br_add()
{
	br_setdir
	local INPUT
	br_promptprt "Choose what you want to add:"
	select opt1 in $STRNUM;do
		if [ $opt1"." = "String." ];then
			br_nprint Enter string:
			read INPUT
			USINGNUM=0
		elif [ $opt1"." = "Number." ];then
			br_nprint Start from:
			read NUM_START
			br_nprint Step:
			read NUM_STEP
			USINGNUM=1
			#init usingnum
		else
			br_errprt "Bad choice."
			continue
		fi
	break
	#only run once
	done
	#number situation escaped
	br_promptprt "Add string as what:"
	select opt2 in $PRESUF;do
		if [ $opt2"." = "Prefix." ];then
			PREFIX=$INPUT
			#let "USINGNUM*=1"
			break
		elif [ $opt2"." = "Suffix." ];then
			SUFFIX=$INPUT
			let "USINGNUM=$USINGNUM*2"
			break
		else
			br_errprt "Bad choice."
		fi
	done
	br_do $BRDIR
}

br_rp()
{
	br_setdir
	br_nprint "Pattern:"
	read PATTERN
	br_nprint "Replace \033[1m$PATTERN\033[22m with:"
	read REPLACE
	br_do $BRDIR
}

br_cmd()
{
	INPUT="none"
	br_promptprt "Command mode. Input e for quit, h for help."
	while [ ! $INPUT"." = "e." ];do
		br_nprint "BR$VERSION>"
		read INPUT
		if [ $INPUT"." = "h." ];then
			br_help
		elif [ ! $INPUT"." = "e." ];then
			$INPUT
		fi
	done
}


br_classic()
{
 	
	if [ $1 = "--help" ];then
		br_help
		exit
	elif [ $1 = "--version" ];then
		br_normalprt $NAME $VERSION
		exit
	fi
	ARG="$2"
	if ! [ "$ARG." = "${ARG/u/}." ];then
		ARG="${ARG//u/}"
		#use saved config
	else
		br_flushconfig
		if ! [ "$ARG." = "${ARG/R/}." ];then
			RECURSE=true
		fi
		if ! [ "$ARG." = "${ARG/s/}." ];then
			SHOWPROGRESS=false
		fi
		if [ "$ARG." = "${ARG/a/}." ];then
			MATCH_ALL=false
		fi
		if ! [ "$ARG." = "${ARG/t/}." ];then
			TESTMODE=true
		fi
	fi
	ARG="${ARG//a/}"
	ARG="${ARG//t/}"	
	ARG="${ARG//R/}"	
	ARG="${ARG//s/}"
		
	if [ "$ARG" = "-r" ];then
		PATTERN=$3
		REPLACE=$4
		BRDIR=$1
	elif [ "$ARG" = "-c" ];then
		PATTERN=$3
		BRDIR=$1
	elif [ "ARG" = "-a" ];then
		BRDIR=$1
		PREFIX=$3
		SUFFIX=$4
	elif [ "$ARG." != "-." ] && [ "$ARG." != "." ];then
		br_errprt "Error parsing arguments: '$ARG' .\nUse --help to see help."
		exit 2
	fi
	#echo 1$SHOWPROGRESS 2$MATCH_ALL 3$RECURSE 4$TESTMODE
	br_do $BRDIR 
}

#Main Entry
br_getconfig
#will judge whether first run
if [ $1"." = "." ];then
	br_helpprt "$NAME by Onion v$VERSION build $BUILD\n$COPYRIGHT"
	br_promptprt "What do you want to do:"
select opt in $OPTS;do
		br_flush
		if [ $opt"." = "Replace." ];then
			br_rp
		elif [ $opt"." = "Cut." ];then
			br_cut
		elif [ $opt"." = "Add." ]; then 
			br_add
		elif [ $opt"." = "Shell." ]; then
			br_cmd
		elif [ $opt"." = "Help." ];then
			br_helpUI
		elif [ $opt"." = "Config." ];then
		br_config
		elif [ $opt"." = "Exit." ];then 
			br_normalprt "$NAME v$VERSION exit successfully"
			br_setconfig
			exit 0
		else
			br_errprt "Bad choice."
		fi
		br_normalprt "\033[1m[Main menu selection]:\033[22m"
		#show prompt at not first time
	done;
else
	br_classic $@
fi
exit 0